import greenfoot.*;  // (Actor, World, Greenfoot, GreenfootImage)

public class CrabWorld extends World
{
    /**
     * Create the crab world (the beach). Our world has a size 
     * of 560x560 cells, where every cell is just 1 pixel.
     */
    public CrabWorld() 
    {
        super(500, 500, 1);
        populateWorld();
    }
    public void populateWorld()
    {
        addObject(new Fighter(), 74, 420);
        addObject(new Enemy(), 426, 420);
        addObject(new Ground(), 74, 474);
        addObject(new Ground(), 426, 474);
        addObject(new Ground(), 124, 474);
        addObject(new Ground(), 174, 474);
        addObject(new Ground(), 214, 474);
        addObject(new Ground(), 264, 474);
        addObject(new Ground(), 304, 474);
        addObject(new Ground(), 354, 474);
        addObject(new Ground(), 364, 474);
    }
}