import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy extends Animal
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    private GreenfootImage image3;
    private GreenfootImage image4;
    private GreenfootImage image5;
    private GreenfootImage image6;
    private GreenfootImage image7;
    private GreenfootImage image8;
    private GreenfootImage image9;
    private GreenfootImage image10;
    private GreenfootImage image11;
    private GreenfootImage image12;
    private GreenfootImage image13;
    private GreenfootImage image14;
    private GreenfootImage image15;
    private GreenfootImage image16;
    private GreenfootImage image17;
    private GreenfootImage image18;
    private boolean isFacingLeft;
    private int waitCycle = 0;
    private int damageDelay = 0;
    private int vSpeed = 0;
    private int acceleration = 2;
    private int hSpeed = 0;
    private int Health = 10;
    /**
     * Act - do whatever the Fighter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Enemy() 
    {
       image1 = new GreenfootImage("Fighter Neutral 1.png");
       image2 = new GreenfootImage("Fighter Neutral 2.png");
       image3 = new GreenfootImage("Fighter Neutral 3.png");
       image4 = new GreenfootImage("Fighter Kick 1.png");
       image5 = new GreenfootImage("Fighter Kick 2.png");
       image6 = new GreenfootImage("Fighter Kick 3.png");
       image7 = new GreenfootImage("Fighter Punch 1.png");
       image8 = new GreenfootImage("Fighter Punch 2.png");
       image9 = new GreenfootImage("Fighter Punch 3.png");
       image10 = new GreenfootImage("Fighter Neutral 1(f).png");
       image11 = new GreenfootImage("Fighter Neutral 2(f).png");
       image12 = new GreenfootImage("Fighter Neutral 3(f).png");
       image13 = new GreenfootImage("Fighter Kick 1(f).png");
       image14 = new GreenfootImage("Fighter Kick 2(f).png");
       image15 = new GreenfootImage("Fighter Kick 3(f).png");
       image16 = new GreenfootImage("Fighter Punch 1(f).png");
       image17 = new GreenfootImage("Fighter Punch 2(f).png");
       image18 = new GreenfootImage("Fighter Punch 3(f).png");
       Health = 10;
       isFacingLeft = true;
    }   
    public void act()
    {
        move();
        attack();
        checkFighter();
        checkFall();
        jump();
    }
    public void move()
    {  
    if (!Greenfoot.isKeyDown("right") && (!Greenfoot.isKeyDown("left")))    
    {      
        waitCycle++;  
        if (waitCycle==18) waitCycle=0;  
        if(isFacingLeft == false)    
        {    
          if (waitCycle==0)    setImage(image1);  
          if (waitCycle==6)    setImage(image2);  
          if (waitCycle==12)  setImage(image3);  
        }    
        if(isFacingLeft == true)  
        {    
          if (waitCycle==0)    setImage(image10);  
          if (waitCycle==6)    setImage(image11);  
          if (waitCycle==12)  setImage(image12);  
        }    
    }   
    
     if (Greenfoot.isKeyDown("right") && (onGround()))
    {
        move(3);
        setImage(image1);
        wait(2);
        setImage(image2);
        move(3);
        wait(5);
        setImage(image3);
        wait(2);
        move(3);
       isFacingLeft = false;
    }
     if(Greenfoot.isKeyDown("right") && (!onGround()))
    {
        isFacingLeft = false;
        setLocation ( getX() + hSpeed, getY());
        hSpeed = 10;
    }
    if (Greenfoot.isKeyDown("left") && (onGround()))
    {
        move(-3);
        setImage(image10);
        wait(2);
        setImage(image11);
        move(-3);
        wait(5);
        setImage(image12);
        wait(2);
        move(-3);
        isFacingLeft = true;
    }
    if(Greenfoot.isKeyDown("left") && (!onGround()))
    {
        setLocation ( getX() + hSpeed, getY());
        hSpeed = -10;
       isFacingLeft = true;
    }
    if(Greenfoot.isKeyDown("up"))
    {
      jump();
    }
}

public void attack()
{
     if (Greenfoot.isKeyDown("k"))
    {
         if (waitCycle==18) waitCycle=0;  
        if(isFacingLeft == false)    
        {    
          if (waitCycle==0)    setImage(image7);  
          if (waitCycle==6)    setImage(image8);  
          if (waitCycle==12)  setImage(image9);  
        }    
        if(isFacingLeft == true)  
        {    
          if (waitCycle==0)    setImage(image16);  
          if (waitCycle==6)    setImage(image17);  
          if (waitCycle==12)  setImage(image18);  
        }    
    }
    if (Greenfoot.isKeyDown("l"))
     {
        if (waitCycle==18) waitCycle=0;  
        if(isFacingLeft == false)    
        {    
          if (waitCycle==0)    setImage(image4);  
          if (waitCycle==6)    setImage(image5);  
          if (waitCycle==12)  setImage(image6);  
        }    
        if(isFacingLeft == true)  
        {    
          if (waitCycle==0)    setImage(image13);  
          if (waitCycle==6)    setImage(image14);  
          if (waitCycle==12)  setImage(image15);  
        }    
    }
}
private void checkFighter()
{
   if(damageDelay > 0) damageDelay--;
   if(damageDelay!=0) return;
   Actor Fighter = getOneIntersectingObject(Fighter.class);
   if(Fighter != null && (Greenfoot.isKeyDown("j")))
   {
       Greenfoot.playSound("slurp.wav");
       Health = Health - 1;
       damageDelay = 15;
    }
     if(Fighter != null && (Greenfoot.isKeyDown("k")))
    {
       Greenfoot.playSound("slurp.wav");
       Health = Health - 1;
       damageDelay = 15;
    }
   if(Health == 0)
   {
       getWorld().removeObject(Fighter);
    }
    if(Health < 0)
    {
        Health = 0;
    }
   
}
private int getHealth()
{
 return Health;
}
public void wait(int time)
{
  Greenfoot.delay(time);
}
public void fall()
{
  setLocation ( getX(), getY() + vSpeed);
  vSpeed = vSpeed + acceleration;
    if(isFacingLeft == true)
  {
  setImage(image10);
}
if(isFacingLeft == false)
  {
  setImage(image1);
}
}
public boolean onGround()
{
  Actor under = getOneObjectAtOffset ( 0, getImage().getHeight() / 2, Ground.class);
  return under != null;
}
public void checkFall()
{
 if(onGround())
 {
     vSpeed = 0;
    }
    else
    {
        fall();
    }
}
private void jump()
{
  if(Greenfoot.isKeyDown("up"))
  {
      vSpeed = -10;
      fall();
  }
}
}